import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OaApp, OaAppParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询应用
 */
export async function pageOaApp(params: OaAppParam) {
  const res = await request.get<ApiResult<PageResult<OaApp>>>(
    MODULES_API_URL + '/oa/oa-app/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用列表
 */
export async function listOaApp(params?: OaAppParam) {
  const res = await request.get<ApiResult<OaApp[]>>(
    MODULES_API_URL + '/oa/oa-app',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用
 */
export async function addOaApp(data: OaApp) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用
 */
export async function updateOaApp(data: OaApp) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用
 */
export async function removeOaApp(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用
 */
export async function removeBatchOaApp(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/oa-app/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用
 */
export async function getOaApp(id: number) {
  const res = await request.get<ApiResult<OaApp>>(
    MODULES_API_URL + '/oa/oa-app/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
